<?php
/*
Plugin Name: bbp Topic deleter
Plugin URI: http://www.rewweb.co.uk
Description: deletes topics and their replies
Version: 1.1
Author: Robin Wilson
Author URI: http://www.rewweb.co.uk
License: GPL2
*/
/*  Copyright 2022  PLUGIN_AUTHOR_NAME  (email : wilsonrobine@btinternet.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	*/
	
add_action('admin_bar_menu', 'trd_add_toolbar_items', 999);

function trd_add_toolbar_items($wp_admin_bar) {
			$wp_admin_bar->add_node( array(
			'id'		=> 'topicdeleter',
			'title' => 'Topic Deleter running',
			'href' => '/wp-admin/admin.php?page=trd_post_displayer',
		) );
}


if(!defined('TRD_PLUGIN_DIR'))
	define('TRD_PLUGIN_DIR', dirname(__FILE__));



include(TRD_PLUGIN_DIR . '/includes/functions.php');
include(TRD_PLUGIN_DIR . '/includes/settings-delete-posts.php');
include(TRD_PLUGIN_DIR . '/includes/settings.php');
include(TRD_PLUGIN_DIR . '/includes/warnings.php');
include(TRD_PLUGIN_DIR . '/includes/transfer_topics.php');
include(TRD_PLUGIN_DIR . '/includes/settings-list-posts.php');





add_action( 'admin_menu', 'trd_plugin_menu' );

function trd_plugin_menu() {
	add_menu_page( 'Topic Deleter', 'Topic Deleter', 'manage_options', 'trd_post_displayer', 'trd_plugin_options' );
}

function trd_plugin_options() {
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}
	echo '<div class="wrap">';
	trd_settings_page() ;
	echo '</div>';
}

//add datepicker
//************

add_action( 'admin_print_scripts', 'trd_datepicker', 1000 );
add_action( 'admin_enqueue_scripts', 'trd_jquery' );

function trd_datepicker() {
	
		?><script type="text/javascript">
			jQuery(document).ready(function(){
				jQuery('.datepicker').datepicker({
					dateFormat : 'd-m-yy',
				});
				
			
			});
		</script>
		
		<?php
		
	}

function trd_jquery() {
wp_enqueue_script('jquery');
wp_enqueue_script('jquery-ui-core');
wp_enqueue_script('jquery-ui-datepicker');
wp_enqueue_style('jquery-ui-css', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/smoothness/jquery-ui.css');
}


//**************end of datepicker








?>