<?php


function trd_delete ($multiple, $post_id, $date, $forum_id, $type) {
	if ($multiple == 0 ) {
	//single topic
		if (empty ($post_id)) {
			echo 'No Topic ID entered' ;
			return ;
		}
		else {
			$post_type = get_post_type ($post_id) ;
			//return if  not valid topic_id 
			if ($post_type != bbp_get_topic_post_type()) {
				echo 'Not a valid Topic ID' ;
				return ;
			}
			if ($type == 0) {
				//list
				$count = trd_count_replies ($post_id) ;
				echo $post_id.' Replies '.$count ;
			}
			else 
			//valid topic id...
			trd_delete_topic ($post_id, $type) ;
		}
	}	
	else {
	//multiple topics			
		$topic_count = 0 ;
		//if this is to delete permanently previously trashed topics them set filter to only pick up trashed
			if ($type == '2') $status = 'trash' ;
			else  $status = 'publish,trash' ;
		//check forum_id is valid (if it is empty then post_parent is not set so we get 'all')
			if (!empty ($forum_id)) {
				$post_type = get_post_type ($forum_id) ;
				//bail if not a forum
				if ($post_type != bbp_get_forum_post_type()) {
					echo 'not a valid Forum ID!!!' ;
					return ;
				}
				
			}
			
		$args = array(
			'post_type' => bbp_get_topic_post_type(),
			'post_parent' => $forum_id,
			'post_status'    => $status,
			'numberposts' => 20000,
		);
		
		//add date to query if specified
		if (!empty ($date)) {
			$args['date_query'] = array(
				'column' => 'post_date_gmt',
				'before' => $date
				) ;	
		}
		
		$topics = get_posts( $args) ;
			
			
			foreach ($topics as $topic) {
				$topic_count++ ;
				$topic_id = $topic->ID ;
				$tstatus = get_post_status ($topic_id) ;
				if ($type == 0) {
					$count = trd_count_replies ($topic_id) ;
					echo '<br>Topic: '.$topic_id.' No. Replies '.$count ;
				}
				else {
					trd_delete_topic($topic_id, $type) ;
				}
				
			}
			echo '<br>Total Topics: '.$topic_count ;
	}
}

function trd_count_replies ($topic_id) {
	$reply_count = 0 ;
	$status = 'publish,trash' ;
	$replies = get_posts( array(
		'post_type' => bbp_get_reply_post_type(),
		'post_parent' => $topic_id,
		'post_status'    => $status,
		'numberposts' => 1000,
	) );
		foreach ($replies as $reply) {
			$reply_count++ ;
		}
	return $reply_count ;
}

function trd_delete_topic ($topic_id, $type) {
	//echo 'deleting...'.$topic_id.' '.$type.'<br/>' ;
	//if ($type == '3') echo 'here type 3' ;
	//echo 'in deleting for '.$topic_id ;
	$reply_count = 0 ;
	//we have to set status, or get_posts only gets live
	if ($type == '2') $status = 'trash' ;
	else  $status = 'publish,trash' ;
	$replies = get_posts( array(
		'post_type' => bbp_get_reply_post_type(),
		'post_parent' => $topic_id,
		'post_status'    => $status,
		'numberposts' => 1000,
	) );
	foreach ($replies as $reply) {
			$reply_count++ ;
			$reply_id = $reply->ID ;
			//echo '<br>here in reply '.$reply_id ;
			if ($type =='1') {
			//1 = trash selected, so do that here
				wp_update_post(
					array(
						'ID'          => $reply_id,
						'post_status' => 'trash',
					)
				);
			}
			elseif ($type == '2' || $type == '3' ) {
			//2 = delete trashed, 3 = delete any - ***TRASHED is set in the get replies query above ***
				global $wpdb;
				// Do raw query. wp_get_post_revisions() is filtered.
				$revision_ids = $wpdb->get_col( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_parent = %d AND post_type = 'revision'", $reply_id ) );
				// Use wp_delete_post (via wp_delete_post_revision) again. Ensures any meta/misplaced data gets cleaned up.
				foreach ( $revision_ids as $revision_id ) {
					$result = $wpdb->delete( $wpdb->posts, array( 'ID' => $revision_id ) );
				}
				$post_meta_ids = $wpdb->get_col( $wpdb->prepare( "SELECT meta_id FROM $wpdb->postmeta WHERE post_id = %d ", $reply_id ) );
				foreach ( $post_meta_ids as $mid ) {
					delete_metadata_by_mid( 'post', $mid );
				}
				$result = $wpdb->delete( $wpdb->posts, array( 'ID' => $reply_id ) );
				//echo '<br> Deleted reply: '.$reply_id.' '.$result ;
			}
		}
	//then trash or delete the topic
	if ($type =='1') {
			//1 = trash selected, so do that here
				wp_update_post(
					array(
						'ID'          => $topic_id,
						'post_status' => 'trash',
					)
				);
				echo '<br> Trashed: '.$topic_id ;
			}
	elseif ($type == '2' || $type == '3' ) {
		//2 = delete trashed, 3 = delete any - ***TRASHED is set in the get topics query above in the main function ***
		global $wpdb;
			// Do raw query. wp_get_post_revisions() is filtered.
			$revision_ids = $wpdb->get_col( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_parent = %d AND post_type = 'revision'", $topic_id ) );
			// Use wp_delete_post (via wp_delete_post_revision) again. Ensures any meta/misplaced data gets cleaned up.
			foreach ( $revision_ids as $revision_id ) {
				$result = $wpdb->delete( $wpdb->posts, array( 'ID' => $revision_id ) );
			}
			$post_meta_ids = $wpdb->get_col( $wpdb->prepare( "SELECT meta_id FROM $wpdb->postmeta WHERE post_id = %d ", $topic_id ) );
			foreach ( $post_meta_ids as $mid ) {
			delete_metadata_by_mid( 'post', $mid );
			}
			$result = $wpdb->delete( $wpdb->posts, array( 'ID' => $topic_id ) );
			echo '<br> Deleted topic: '.$topic_id.' and '.$reply_count.' replies';
	}
}

function trd_transfer($ffrom, $fto, $date) {
	
	if (!empty ($ffrom)) {
				$post_type = get_post_type ($ffrom) ;
				//bail if not a forum
				if ($post_type != bbp_get_forum_post_type()) {
					echo 'not a valid FROM Forum ID!!!' ;
					return ;
				}
	}
	if (!empty ($fto)) {
				$post_type = get_post_type ($fto) ;
				//bail if not a forum
				if ($post_type != bbp_get_forum_post_type()) {
					echo 'not a valid TO Forum ID!!!' ;
					return ;
				}
	}
	$topic_count = 0 ;
	$topics = get_posts( array(
			'post_type' => bbp_get_topic_post_type(),
			'post_parent' => $ffrom,
			'post_status'    => 'any',
			'numberposts' => 20000,
			'date_query' => array(
				'column' => 'post_date_gmt',
				'before' => $date
				)
       		) );
			
			foreach ($topics as $topic) {
				$topic_count++ ;
				$topic_id = $topic->ID ;
				wp_update_post(
					array(
						'ID' => $topic_id, 
						'post_parent' => $fto
					)
				);
				//and update forum in post meta
				update_post_meta ($topic_id, '_bbp_forum_id' , $fto) ;
				echo '<br> Transferred topic: '.$topic_id;
			}
echo '<br>Total Topics transferred: '.$topic_count ;		
}

function trd_list($date, $forum_id){
	if (!empty ($forum_id)) {
				$post_type = get_post_type ($forum_id) ;
				//bail if not a forum
				if ($post_type != bbp_get_forum_post_type()) {
					echo 'not a valid Forum ID!!!' ;
					return ;
				}
				
			}
	$args = array(
			'post_type' => bbp_get_topic_post_type(),
			'post_parent' => $forum_id,
			'post_status'    => 'publish,trash',
			'numberposts' => 20000,
		);
		
		//add date to query if specified
		if (!empty ($date)) {
			$args['date_query'] = array(
				'column' => 'post_date_gmt',
				'before' => $date
				) ;	
		}
		
		$topics = get_posts( $args) ;
			$topic_count = 0 ;
		echo '<table>' ;
		echo '<tr><th>Topic</th><th>Date</th><th>Status</th><th>No. Replies</th><th>Title</th></tr>' ;
			foreach ($topics as $topic) {
				$topic_count++ ;
				$topic_id = $topic->ID ;
				$status = get_post_status ($topic_id) ;
				$title = get_the_title ($topic_id) ;
				$date = get_the_date ('',$topic_id) ;
				$count = trd_count_replies ($topic_id) ;
					echo '<tr><td style="text-align:center;">'.$topic_id.'</td><td style="text-align:center;">'.$date.'<td style="text-align:center;">'.$status.'</td><td style="text-align:center;">'.$count.'</td><td>'.$title.'</tr>' ;
			}
			echo '</table>' ;
			echo '<br>Total Topics: '.$topic_count ;
	
	
}
